#define F_CPU 8000000UL  //    
   
#include <avr/io.h>
#include <util/delay.h>
   
#define true 1
#define false 0
   
/*
 *  motor 1 | 2
 *  direction 0 == stop | 1 == forward | 2 == backward 
 */
void motor(short int motor, short int dir)
{
	switch (motor) {
		case 0:	{
			switch (dir) {
				case 0:	{
					PORTC &= ~_BV(PC0);
					PORTC &= ~_BV(PC1);
					break;
				}
				case 1: {
					PORTC |= _BV(PC0);
					PORTC &= ~_BV(PC1);
					break;
				}
				case 2: {
					PORTC &= ~_BV(PC0);
					PORTC |= _BV(PC1);			
					break;
				}
			}
			break;
		}
		case 1: {		
			switch (dir) {
				case 0: {
					PORTC &= ~_BV(PC2);
					PORTC &= ~_BV(PC3);
					break;
				}
				case 1: {
					PORTC |= _BV(PC2);
					PORTC &= ~_BV(PC3);
					break;
				}
				case 2: {
					PORTC &= ~_BV(PC2);
					PORTC |= _BV(PC3);
					break;
				}
			}
			break;
		}
	}
}

/*
 *  UART
 */
void uart_init( void ) {

#define BAUD 9600
#define MYUBRR F_CPU/16/BAUD-1

    UBRRH = MYUBRR >> 8;
    UBRRL = MYUBRR;
    UCSRB = (1<<RXEN)|(1<<TXEN);
	UCSRC = ( 1 << URSEL ) | ( 1 << UCSZ1 ) | ( 1 << UCSZ0 );
}
 
unsigned char uart_getc( void ) {
   //  
   while( ( UCSRA & ( 1 << RXC ) ) == 0  );
   //  
   return UDR;
}
 
void uart_putc( char c ) {
  //    
  while( ( UCSRA & ( 1 << UDRE ) ) == 0 );
  UDR = c;
}
 
void uart_puts( char *str ) {
  unsigned char c;
  while( ( c = *str++ ) != 0 ) {
    uart_putc( c );
  }
}

/*
 *  MAIN
 */
int main(void)
{
   
	DDRC	= 0xff; //  293
	DDRB	|= 1<<0; //  

	uart_init();
	uart_puts( "Hello uart\r\n" );

	uart_puts("Hello uart");
		
	while (1)
	{
		motor(0, 2);		
		motor(1, 1);
	}
}
